文章目录
- 0. Leetcode [1512. 好数对的数目](https://leetcode-cn.com/problems/number-of-good-pairs/)
- 1. Leetcode [2006. 差的绝对值为 K 的数对数目](https://leetcode-cn.com/problems/count-number-of-pairs-with-absolute-difference-k/)
- 2. Leetcode [1347. 制造字母异位词的最小步骤数](https://leetcode-cn.com/problems/minimum-number-of-steps-to-make-two-strings-anagram/)
- 3. Leetcode [面试题 10.02. 变位词组](https://leetcode-cn.com/problems/group-anagrams-lcci/)
- 总结
0. Leetcode 1512. 好数对的数目
给你一个整数数组 nums 。
如果一组数字 (i,j) 满足 nums[i] == nums[j] 且 i < j ,就可以认为这是一组 好数对 。
返回好数对的数目。
提示:
1 <= nums.length <= 100
1 <= nums[i] <= 100
分析与解答
由于数组中的值上限为 100,因此可以用直接映射的方式将数组中的数映射到哈希表中相应下标,由于题目只要求 nums[i] == nums[j]
,因此可以通过映射后 /2
的方式去除 i >= j
的重复计算情况。
class Solution {
public:
int numIdenticalPairs(vector<int>& nums) {
int numMap[100]{0};
for (auto num: nums) {
numMap[num - 1]++;
}
int result(0);
for (int i = 0; i < 100; i++) { // 对 n 个相同数,有 n-1*n / 2 个满足条件的数对
result += (numMap[i] - 1) * numMap[i];
}
return result / 2;
}
};
算法时间复杂度为 O ( N ) O(N) O(N)
1. Leetcode 2006. 差的绝对值为 K 的数对数目
给你一个整数数组 nums 和一个整数 k ,请你返回数对 (i, j) 的数目,满足 i < j 且 |nums[i] - nums[j]| == k 。
|x| 的值定义为:
如果 x >= 0 ,那么值为 x 。
如果 x < 0 ,那么值为 -x 。
提示:
1 <= nums.length <= 200
1 <= nums[i] <= 100
1 <= k <= 99
分析与解答
将数组中的数直接映射到哈希表 numMap0
中,从头至尾遍历 numMap
,当对应位置有值时,更新结果数量:
class Solution {
public:
int countKDifference(vector<int>& nums, int k) {
int result(0);
int numMap[101]{0};
for (int i = 0; i < nums.size(); ++i) { // 构建哈希表
numMap[nums[i]]++;
}
for (int i = 0; i < 101; ++i) {
int idx = i + k;
if (numMap[i] != 0 && idx < 101) {
if (numMap[idx] != 0) { // 能按顺序组成的数对个数为 numMap[i] * numMap[j]
result += numMap[i] * numMap[idx];
}
}
if (idx > 100) {
break;
}
}
return result;
}
};
算法时间复杂度为 O ( N ) O(N) O(N)
对于有顺序要求的数对,也可在插入时进行查找,这样能确保答案顺序。
2. Leetcode 1347. 制造字母异位词的最小步骤数
给你两个长度相等的字符串 s 和 t。每一个步骤中,你可以选择将 t 中的 任一字符 替换为 另一个字符。
返回使 t 成为 s 的字母异位词的最小步骤数。
字母异位词 指字母相同,但排列不同(也可能相同)的字符串。
分析与解答
构造字符串的哈希表,比较另一个字符串中字符出现次数,将差值累加即可:
class Solution {
public:
int minSteps(string s, string t) {
// 根据题意只要两个字符串中字符相同即可
// 26 个小写字母可以直接映射
int set0[26]{0};
for (auto ch: s) {
// 构造映射
set0[ch - 'a']++;
}
int result(0);
for (auto ch: t) {
// 若计数为 0 则为多的字符(多一个意味少一个,成对出现)
if (set0[ch - 'a'] == 0) {
result++;
} else {
set0[ch - 'a']--;
}
}
return result;
}
};
算法时间复杂度为 O ( N ) O(N) O(N)
3. Leetcode 面试题 10.02. 变位词组
编写一种方法,对字符串数组进行排序,将所有变位词组合在一起。变位词是指字母相同,但排列不同的字符串。
分析与解答
由于变位词组中字符相同,因此可以使用排序后的字符串(变位词组中字符位置可能不同)作为键值,在 unordered_map
中进行映射(尚未学会手撸哈希表…)
class Solution {
public:
vector<vector<string>> groupAnagrams(vector<string>& strs) {
unordered_map<string, vector<string>> unMap;
for (auto str: strs) {
string key = str;
sort(key.begin(), key.end());
unMap[key].push_back(str);
}
vector<vector<string>> result;
for (auto& [_, v]: unMap) {
result.push_back(v);
}
return result;
}
};
算法时间复杂度为 O ( N ) O(N) O(N)
总结
- 初次刷哈希表题目,有的题目中的映射关系显而易见,有的题目中映射关系不是那么明显。找到正确的映射关系能够事半功倍。
- 对于有顺序要求的答案,可在构造哈希表时进行查找,这样可以确保答案顺序。